## HISTORY (ChangeLog)

- v.6.1.8 (2026-09-01)
    - Minor UI/UX improvements.
    - Moved mcdx location.
    - Accelerated mcdx.
    - Accelerated loading RC files.
- v.6.1.7 (2026-08-25)
    - Fixed MEditAccelDlg bug ("^A" etc.).
    - Made mcdx less suspicious.
    - Fixed MessageRes dumping.
- v.6.1.6 (2026-08-24)
    - Minor UI/UX improvements.
    - Added [Help] button to MConstantDlg.
    - Fixed crash in MRadWindow::AlignSelection.
    - Improved installer translation.
    - Fixed EGA RES_delete crash.
    - Fixed MEditAccelDlg bug ("^A" etc.).
    - Accelerated resource item handling.
    - Fixed the incorrect display of the RISOHTEMPLATE resource name.
    - Fixed RT_BITMAP importing, extracting, and saving.
    - Don't quote resource names for MSVC compatibility.
- v.6.1.5 (2026-08-22)
    - Accelerated MDialogFontSubstDlg.
    - Added the splash window.
    - Made windres default codepage UTF-8.
    - Fixed RT_BITMAP extraction.
    - Added confirmation before deletion.
    - Added sanity check for menu items.
    - Minor UI/UX improvements.
- v.6.1.4 (2026-08-13)
    - Made configuration a property sheet.
    - Accelerated OnDeleteRes.
    - Prevented the tree view's drop-down arrow from appearing twice.
    - Fixed MRadWindow index labels.
    - Supported resource compression by WonRes.
    - Improved UPX handling.
    - Enhanced support for Help IDs.
    - Improved MEditMenuDlg.
    - Supported zooming of code editor.
    - Fixed word wrap.
- v.6.1.3 (2026-08-08)
    - Simplified [Edit] menu.
    - Implemented resource encryption using WonRes.
    - Accelerated OnNew.
    - Added support for RLE-compressed BMPs.
    - Reduced flickering of MRadWindow.
    - Reduced flickering of m_hCodeEditor.
- v.6.1.2 (2026-08-05)
    - Able to build with MinGW or RosBE again.
    - Able to change resource type.
    - Able to clone resource type.
    - Minor UI/UX improvements.
    - Fixed the handling of DLGITEMTEMPLATE.
    - Updated mcpp.exe to process the source line information.
    - Improved compilation process and error info.
- v.6.1.1 (2026-08-03)
    - Refactoring.
- v.6.1.0 (2026-08-03)
    - Fixed uninitialized handle on treeview arrow.
    - Improved Polish translation.
- v.6.0.9 (2026-08-02)
    - Updated EGA manual.
    - Fixed treeview display delay.
- v.6.0.8 (2026-08-01)
    - Improved MConstantDlg.
    - Improved MAddCtrlDlg, MCtrlPropDlg, and MDlgPropDlg.
    - Fixed missing Portuguese resource strings.
    - Reduced the size of IDD_EGA.
    - Made resource preview safer.
    - Improved EGA dialog output.
    - Fixed EGA "load" and "save" functions.
    - Added EGA "RES_extract" function.
    - Fixed EGA "RES_load" and "RES_save" functions.
    - Improved translation and access keys.
- v.6.0.7 (2026-07-24)
    - Fixed source view wheel scroll slowness.
    - Fixed DIALOG style dumping.
    - Improved RT_VERSION dumping.
    - Fixed RT_VERSION data.
    - Fixed BUTTON and RICHEDIT styles.
    - Improved keyword help.
- v.6.0.5 (2026-07-17)
    - Enabled the treeview arrow to change the resource name.
    - Fixed EGA. Added some EGA programs.
    - Used DIALOGEX instead of DIALOG.
    - Improved DIALOGEX FONT dumping.
    - Improved handling when multiple controls are selected in IDD_CTRLPROP.
    - Enabled input auto completion on name item of treeview.
    - Fixed item deletion on treeview.
- v.6.0.4 (2026-07-07)
    - Fixed the interpretation of the tree view resource ID.
    - Added "Reset" button on IDD_FONTS dialog.
- v.6.0.3 (2026-07-05)
    - Allowed signed/unsigned 32-bit integer for Help ID in "Resource IDs" dialog.
    - Finalizing the localization.
    - Fixed minor "Resource IDs"' bug.
    - Correctly handling quoted resource names.
    - Improved RT_VERSION dumping.
    - Added "winres.h".
    - Added "Item Help" feature on TreeView.
    - Omitting string table commas.
    - Supported context help (F1).
    - Always using uppercase for resource ID strings.
    - Avoided division by zero in the macro parser.
- v.6.0.2 (2026-07-03)
    - Improved Polish (Poland) translation (thanks, Fresta).
    - Fixed "List of Resource IDs" ID_BASE10 and ID_BASE16 actions.
    - Renamed "List of Resource IDs" as "Resource IDs".
    - Fixed "Resource IDs" UI/UX.
- v.6.0.1 (2026-06-01)
    - Optimized "List of Resource IDs".
    - Added Ukrainian (Ukraine) translation.
- v.6.0.0 (2026-05-21)
    - Fixed some minor UI/UX bugs.
    - Changed bUseMSMSGTABLE to the default setting.
- v.5.9.9 (2026-05-20)
    - Fixed msdx.
    - Fixed resource ID handling.
    - Fixed message table handling.
    - Modified to accept UTF-16 code pages.
- v.5.9.8 (2026-05-15)
    - Made codepage support safer.
    - Added Portuguese (Portugal) translation.
    - Introduced WonRes (original resource manipulator).
    - Fixed IDD_IDLIST dialog behavior.
    - Fixed a bug that caused the application to crash when 'L' was pressed in MRadWindow.
    - Validating integer IDs.
- v.5.9.7 (2026-05-03)
    - Supported RichEdit20A/RichEdit20W/RichEdit50W.
    - Supported codepages.
- v.5.9.6 (2026-04-02)
    - Fixed version info.
    - Localized version info (RT_VERSION) templates.
- v.5.9.5 (2026-03-01)
    - Relaxed the buffer size.
- v.5.9.4 (2026-01-01)
    - Updated mcpp.exe to make UTF-16/UTF-32 buffer length unlimited.
    - Renamed HISTORY*.txt as ChangeLog*.txt.
    - Renamed README-*.txt as README_*.txt.
    - Added the "Go to line" feature.
- v.5.9.3 (2025-12-01)
    - Fixed AutoComplete case-insensitiveness problem.
    - Fixed handling of resource name zero.
    - Implemented TEXTINCLUDE 1.
    - Fixed many memory leaks.
    - Supported MP3 sounds.
    - Fixed menu empty quotes problem.
- v.5.9.2 (2025-10-23)
    - Fixed double signature problem.
- v.5.9.1 (2025-10-23)
    - Now, the maximum length of a non-wrapped string literal is 400.
    - Wrap string literals only in UTF-16 RC.
    - Fixed Search (Ctrl+F).
    - ANICURSOR and ANIICON keywords are not available on old environments. Use numeric instead of them.
    - Improved Search UI/UX.
    - Added "(bom)" option to EGA RES_save function.
    - Added High DPI support.
- v.5.9.0 (2025-09-01)
    - Supported rc2 filename extension.
    - Notified icon change on extracting file by SHChangeNotify.
    - Enabled wrapping of excessively long string literals.
    - It is now possible to add a Byte Order Mark (BOM) when outputting an RC file.
- v.5.8.9 (2025-07-01)
    - Notified icon change on saving EXE file by SHChangeNotify.
    - Added English "Neutral" entry to the language list.
    - Fixed initial language list box selection.
    - Correctly retrieving info of RLE Bitmap.
    - Reduced flickering when moving the splitter.
    - Disabled WoW filesystem redirection.
    - Enabled filesystem auto-completion.
- v.5.8.8 (2025-06-03)
    - Added digital signature to EXE files.
    - Added Turkish translation.
    - Supported TEXTINCLUDE 2 and TEXTINCLUDE 3.
    - Fixed MRadWindow crash.
    - Updated installers.
- v.5.8.7 (2025-04-04)
    - Reduced memory leaks and handle leaks.
    - Improved main icon.
    - Improved adding icon/cursor/bitmap/resource UI/UX.
- v.5.8.6 (2025-02-04)
    - Added Spanish translation.
    - Fixed RES_save function for saving *.dll.
    - Don't use SUBLANG_CUSTOM_DEFAULT, SUBLANG_CUSTOM_UNSPECIFIED, and SUBLANG_UI_CUSTOM_DEFAULT for backward compatibility.
- v.5.8.5 (2024-08-21)
    - Improved EGA console usability.
    - Abolished EGA input function.
- v.5.8.4 (2024-08-02)
    - Separated x86 and x64 settings.
    - Fixed misinterpretation of open filter index.
- v.5.8.3 (2024-07-24)
    - Auto filling resource name from filename.
    - Added resource language setting.
    - Fixed freeze on Enter key.
    - Supported x64.
- v.5.8.2 (2024-07-20)
    - Added ES_AUTOHSCROLL style to some text boxes.
    - Fixed loading failure of Win2k3 ieframe.dll BITMAP 214.
    - Centering "Edit Dialog" window.
    - Supported exporting RES file.
- v.5.8.1 (2024-03-04)
    - Improved IDD_ADDCTRL and IDD_CTRLPROP dialogs.
- v.5.8.0 (2024-03-03)
    - Coping with security scan when generating EXE files.
- v.5.7.9 (2023-11-14)
    - Added EGA sample DeleteNonEnglish.ega.
    - Fixed IDS_THEREISUPDATE translation.
- v.5.7.8 (2023-10-06)
    - Improved Portuguese (Brazilian) translation.
    - Relaxed font selection requirements.
    - Added Traditional Chinese translation.
- v.5.7.7 (2023-06-05)
    - Commonized IDD_ADDDLGINIT and IDD_MODIFYDLGINIT.
    - Changed the design of RES_str_get and RES_str_set.
    - Added RES_get_text and RES_set_text functions to EGA.
- v.5.7.6 (2023-06-02)
    - Localized the Help menu.
    - Added RES_str_get and RES_str_set functions to EGA.
- v.5.7.5 (2023-05-08)
    - Improved IDD_DLGPROP, IDD_CTRLPROP, IDD_ADDCTRL dialogs.
    - Added Korean installer.
    - Fixed MENUEX separator.
- v.5.7.4 (2023-04-02)
    - Added version numbers to IDS_NOTICE.
    - Improved EGA console.
    - Fixed half-broken installer.
- v.5.7.3 (2023-04-01)
    - Minor performance improvements.
    - Improved "Copy to multiple languages".
    - Fixed FILESUBTYPE of VERSIONINFO.
    - Made "~" the backup suffix rather than "-old".
    - Renamed "Replacing Dialog Fonts..." as "Dialog font substitutes..."
- v.5.7.2 (2022-06-07)
    - Supported TOOLBAR resources.
- v.5.7.1 (2022-03-28)
    - Improved version info dialog.
    - Backed to a flickering method due to wrong control display.
    - Remembered main window focus.
- v.5.7.0 (2022-03-18)
    - Fixed recompilation in management of resource IDs.
- v.5.6.9 (2022-03-09)
    - Splited the history text.
    - Renamed READMEs.
    - Added WS_CLIPCHILDREN for RAD window to reduce flickering.
- v.5.6.8 (2022-01-17)
    - Changed the initial focus of IDD_CTRLPROP.
    - Fixed some version info.
- v.5.6.7 (2022-01-13)
    - Added Portuguese translation.
    - WinXP support again (don't use GetThreadUILanguage() in XP).
- v.5.6.6 (2021-12-25)
    - Double-clicking the RAD window opens the control/dialog properties.
    - Improved ANI cursor support.
- v.5.6.5 (2021-12-18)
    - A BS_OWNERDRAW button is a PUSHBUTTON.
    - Added "Copy to multiple languages" feature.
    - Fixed the bug of the RAD window (Critical).
- v.5.6.4 (2021-12-16)
    - Asking for compiling before opening GUI edit.
- v.5.6.3 (2021-12-12)
    - Added win32-samples.
    - Added "UI Lanuage Select".
- v.5.6.2 (2021-08-15)
    - Enlarged width of "Save Options" and "Export Options" dialogs.
    - Added workaround to add message tables on Microsoft compatible mode.
- v.5.6.1 (2021-07-01)
    - Fixed the return value of process.
    - Improved message table handling.
    - Don't change the case of name when renaming it in TreeView.
- v.5.6.0 (2021-06-19)
    - Don't compress dfmsc.exe (for security).
    - Supported command line.
    - Added RES_load and RES_save functions to EGA language.
- v.5.5.9 (2021-06-16)
    - Fixed loading resource.h macros.
- v.5.5.8 (2021-06-15)
    - Marks line upon happening error.
    - Fixed Ctrl+A.
    - Updated mcpp.exe and dfmsc.exe.
- v.5.5.7 (2021-06-12)
    - Added line numbers.
- v.5.5.6 (2021-04-29)
    - Made *.rc files importable.
    - Fixed TreeView languages arrow display.
- v.5.5.5 (2021-04-23)
    - Deleted tlb2idl programs.
    - Added OleBow program to process TYPELIB resource type.
    - Compiling TYPELIB if MIDL compiler is available.
- v.5.5.4 (2021-04-13)
    - Fix importing Vista icons.
- v.5.5.3 (2021-03-30)
    - Upgraded windres.exe to 2.36.1.
    - Used short pathname to spawn subprocesses of mcpp.exe and windres.exe.
- v.5.5.2 (2021-02-27)
    - Fixed Ctrl+A on textboxes of Win2k3.
    - Added tlb2idl programs to process TYPELIB resource type.
    - Supported TYPELIB preview.
    - Added Polish translation.
    - Disabled "Wrap the manifest statements" feature as default.
- v.5.5.1 (2021-02-02)
    - Upgraded windres to 2.36.
    - The menu items of BITMAP or OWNERDRAW can be compiled.
- v.5.5.0 (2021-01-26)
    - Add Korean translation.
- v.5.4.9 (2021-01-21)
    - Refresh ID List upon renaming treeview item.
- v.5.4.8 (2020-11-12)
    - Added Finnish translation.
    - Added *.rc and *.res file association.
    - Initial support of OLE controls.
    - Deleted MOleCtrl and added MOleHost.
    - Supported REGINST data.
- v.5.4.7 (2020-10-18)
    - Downgraded Inno Setup to 5.6.1 for XP support.
    - Initial support of ActiveX window class "AtlAxWin140" on test dialog.
- v.5.4.6 (2020-10-03)
    - Deleted cache in version check.
    - Fixed test dialog position.
    - Fixed a bug that `RT_DLGINIT` disappears without permission.
- v.5.4.5 (2020-08-03)
    - Added Indonesian translation.
    - Added auto complete for language combo boxes.
- v.5.4.4 (2020-07-09)
    - Flushed file contents before using it.
    - Supported international Delphi DFM data.
    - Inserted "Delphi DFM Settings" menu item into "Edit" menu.
    - Correctly reset checksum to zero when saving file.
    - Fixed a bug in which a control is shifted by 1 pixel.
    - Added some waits upon file saving, for virus checker.
    - Added "A Guide to RisohEditor" link to "Help" menu.
- v.5.4.3 (2020-07-03)
    - Improved extraction filename.
    - Sorted the treeview items upon change of resource name/language.
    - Improved icon/cursor extraction.
    - Improved newline codes of encoded text.
    - Fixed "Add Resource" dialog.
    - Made HTML/Manifest importable.
    - Added update check feature in "Help" menu.
    - Fixed title of message box.
    - Relaxed the character limit and supported large data.
    - Reset checksum to zero when saving file.
- v.5.4.2 (2020-06-18)
    - Added tab control to choose "Code Editor" or "Hex Viewer".
    - Improved German and French translations.
    - Fixed language drop-down arrow.
    - Fixed Unicode encoding processing.
    - Improved exporting and extracting.
    - Improved EGA dialog.
- v.5.4.1 (2020-06-14)
    - Fixed the bug that the second overwrite save fails.
    - Fixed title bar text.
    - Fixed status bar message.
    - Added German translation.
    - Added French translation.
- v.5.4.0 (2020-06-13)
    - Fixed `RT_ACCELERATOR` output (unsigned 16-bit).
    - Removed "Store into res folder" option.
    - Fixed crash upon GUI edit.
    - Strengthened extraction feature.
    - Fixed replacing-dialog-font feature.
    - Used the full path for title bar.
    - Added drop-down language arrow.
    - Fixed "Query Constant" dialog.
    - Fixed "Encoding of Resource Item" dialog.
    - Improved "ID Association" dialog.
    - Improved "Predefined Macros" dialog.
    - Improved "Configuration" dialog.
    - Fixed "Search" dialog.
    - Improved status message.
    - Improved modified flag handling.
- v.5.3.9 (2020-06-01)
    - Added "replacing-dialog-fonts" feature.
    - Moved some menu items to "Edit" menu.
    - Added value-zero-check of resource name and resource type.
    - Added `DS_CENTER` style to the sample resource dialog.
    - Enabled F1, F3, F5 and F6 function keys.
    - Added Portable version.
    - Improved search feature.
- v.5.3.8 (2020-05-22)
    - Added "Open EGA Manual" item to "Automation" menu.
    - Strictly controlled the file change flag.
- v.5.3.7 (2020-04-28)
    - Updated file change flag when file drop.
    - Improved the filename when extracting.
    - Strengthened EGA.
    - Improved Russian translation.
- v.5.3.6 (2020-04-15)
    - The infinite loop is avoided by changing the loop variables to 32-bits.
    - Delphi DFM data support.
    - Improved context menu.
- v.5.3.5 (2020-03-26)
    - Improve Italian translation.
    - Fix needless save confirmation.
- v.5.3.4 (2020-03-19)
    - Changed toolbar save button behavior.
    - Introduced automation by using programming language EGA.
    - Added confirmation of saving changes of file.
- v.5.3.3 (2020-03-03)
    - Reduced file size from 9MB to 3MB.
- v.5.3.2 (2020-03-02)
    - Able to save with `Ctrl+S` without querying the location.
    - Made the "Output RC files as UTF-16" option non-volatile.
    - Bring "List of Resource IDs" window to top.
- v.5.3.1 (2020-02-23)
    - Fix and improve menu resource reading/displaying.
    - Improved `IDC_STATIC` handling.
    - Improved "List of Resource IDs" window.
- v.5.3.0 (2020-02-06)
    - Added `ES_AUTOHSCROLL` to some textboxes.
    - Fixed the logical error upon overwriting file.
- v.5.2.9 (2020-02-01)
    - XP support of 5.2.8 is forgotten. Now enabled.
    - Fixed processing of file saving.
    - Able to save EXE/DLL files without user-owned executable.
    - Fixed how to backup.
- v.5.2.8 (2020-01-30)
    - Fix Russian translation.
    - Able to display undefined controls.
    - Added "Use BEGIN/END" option.
    - Fixed a bug that DLL could not be saved as another name.
- v.5.2.7 (2019-10-20)
    - Improved Languages dialog again.
    - Fix the positions of the dialog item marks.
- v.5.2.6 (2019-09-23)
    - Improve Languages dialog.
    - Add Russian translation.
    - Show error message if the installed location has space characters.
    - Add `--use-temp-file` option in invoking `windres` to fix the `popen` problem.
- v.5.2.5 (2019-09-19)
    - Fixed a `WS_CHILDWINDOW` bug in dialog style listbox.
    - Changed the release filename (`RisohEditor-X.X.X.exe` and `RisohEditor-X.X.X.zip`).
    - Added `TRANSLATORS.txt`.
    - Made owner-drawn controls visible.
- v.5.2.4 (2019-09-15)
    - XP support.
- v.5.2.3 (2019-09-14)
    - Fix `AUTORADIOBUTTON` `STYLE`.
- v.5.2.2 (2019-08-14)
    - Update Italian translation.
    - Support XML, XSLT, SCHEMA and REGISTRY resource types.
    - Improved interpretation when language mismatch of `RT_ICON`/`RT_CURSOR` and `RT_GROUP_ICON`/`RT_GROUP_CURSOR`.
    - Improved interpretation when language mismatch of `RT_DLGINIT` and `RT_DIALOG`.
- v.5.2.1 (2019-08-04)
    - "English (United States)" will be selected if you entered `"En"` for language name.
    - Add "Query Constant" feature.
    - Fix "Collapse All".
    - `WS_POPUPWINDOW | WS_BORDER` must be `WS_POPUPWINDOW | WS_CAPTION`.
    - `RT_FONT` support.
    - Improved "Add Resource" dialog.
- v.5.2.0 (2019-07-26)
    - Correctly treat `DIALOG STYLE` values (`WS_CAPTION` is default value of `DIALOG STYLE`).
    - Fixed a bug that the application unexpectedly deletes the file when it opened a compressed EXE file without expanding.
- v.5.1.9 (2019-07-14)
    - Supported UTF-16 source input/output.
- v.5.1.8 (2019-05-14)
    - Add check of recompilation upon cloning.
    - Fix the selection after cloning.
    - Correctly fail upon compilation error of string table and message table.
- v.5.1.7 (2019-03-20)
    - Add PBS_MARQUEE and PBS_SMOOTHREVERSE styles.
    - Fix the process of compilation error.
- v.5.1.6 (2019-02-24)
    - Improve Italian translation.
    - GUI adjustment.
    - Fix "Clone In New Language".
- v.5.1.5 (2019-01-27)
    - Don't use WS_EX_MDICHILD extended style.
    - Support ReactOS.
- v.5.1.4 (2019-01-13)
    - Add English installer.
    - Add Italian installer.
    - Add Italian translation.
    - Add some language installer.
- v.5.1.3 (2019-01-01)
    - Fix "List of Resource IDs".
- v.5.1.2 (2018-12-08)
    - Accept space in the window class name text box.
    - Accept C string literal in the window class name text box.
    - Improve template system.
    - Enable manifest template.
    - Fix toolbar UI update.
    - Correctly display ID types of "List of Resource IDs".
    - Correctly sort the languages upon output.
- v.5.1.1 (2018-11-08)
    - Accept space in the caption text box.
    - Accept space in the language text box.
- v.5.1.0 (2018-10-08)
    - Improve "String Entry" dialogs (multiline).
    - Fix Ctrl+A behaviour.
    - Check file lock on saving a file.
    - Make resource IDs case sensitive.
    - Support encoding of resource items.
    - Fix the abnormal termination at "Languages" dialog.
- v.5.0.9 (2018-09-27)
    - Improve resource.h output.
    - Improve treeview file icon.
    - Improve importing.
- v.5.0.8 (2018-09-12)
    - Improve tool bar icons.
    - Fix the file types on extraction.
    - Write dagger to source file to help UTF-8 detection.
    - Fix the treeview icons.
    - Split the RT_DIALOG and RT_MENU resource templates in languages.
- v.0.6 (2017-08-31)
    - First release.
